Coin: SbBox3f Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SbBox3f Class Reference
Base Classes

The SbBox3f class is an abstraction for an axis aligned 3 dimensional box. More...

`#include <Inventor/SbBox3f.h>`

Inheritance diagram for SbBox3f:

## Public Member Functions
| SbBox3f (void)
| SbBox3f (float xmin, float ymin, float zmin, float xmax, float ymax, float zmax)
| SbBox3f (const SbVec3f &minpoint, const SbVec3f &maxpoint)
| SbBox3f (const SbBox3d &box)
| SbBox3f (const SbBox3s &box)
| SbBox3f (const SbBox3i32 &box)
SbBox3f & | setBounds (float xmin, float ymin, float zmin, float xmax, float ymax, float zmax)
SbBox3f & | setBounds (const SbVec3f &minpoint, const SbVec3f &maxpoint)
SbBox3f & | setBounds (const SbBox3d &box)
SbBox3f & | setBounds (const SbBox3s &box)
SbBox3f & | setBounds (const SbBox3i32 &box)
void | getBounds (float &xmin, float &ymin, float &zmin, float &xmax, float &ymax, float &zmax) const
void | getBounds (SbVec3f &minpoint, SbVec3f &maxpoint) const
const SbVec3f & | getMin (void) const
SbVec3f & | getMin (void)
const SbVec3f & | getMax (void) const
SbVec3f & | getMax (void)
void | extendBy (const SbVec3f &pt)
void | extendBy (const SbBox3f &box)
void | transform (const SbMatrix &matrix)
void | makeEmpty (void)
SbBool | isEmpty (void) const
SbBool | hasVolume (void) const
float | getVolume (void) const
SbBool | intersect (const SbVec3f &pt) const
SbBool | intersect (const SbBox3f &box) const
SbVec3f | getClosestPoint (const SbVec3f &point) const
SbBool | outside (const SbMatrix &mvp, int &cullbits) const
SbVec3f | getCenter (void) const
void | getOrigin (float &originX, float &originY, float &originZ) const
void | getSize (float &sizeX, float &sizeY, float &sizeZ) const
SbVec3f | getSize (void) const
void | getSpan (const SbVec3f &dir, float &dmin, float &dmax) const
void | print (FILE *file) const

## Related Symbols
(Note that these are not member symbols.)
int | operator== (const SbBox3f &b1, const SbBox3f &b2)
int | operator!= (const SbBox3f &b1, const SbBox3f &b2)

## Detailed Description

The SbBox3f class is an abstraction for an axis aligned 3 dimensional box.

This box abstraction class is used by other entities in the Coin library for data exchange and storage. It provides a representation of the defining corners of a box in 3D space, with the sides aligned with the 3 principal axes.

See also
  SbBox2s, SbBox2f, SbBox2d, SbBox3s, SbBox3d, SbXfBox3f.

## Constructor & Destructor Documentation

## ◆ SbBox3f() [1/6]

SbBox3f::SbBox3f | ( | void |  | ) |
| inline

The default constructor makes an empty box.

## ◆ SbBox3f() [2/6]

SbBox3f::SbBox3f | ( | float | minx,
|  | float | miny,
|  | float | minz,
|  | float | maxx,
|  | float | maxy,
|  | float | maxz )
| inline

Constructs a box with the given corners.

minx should be less than maxx, miny should be less than maxy and minz should be less than maxz if you want to make a valid box.

## ◆ SbBox3f() [3/6]

SbBox3f::SbBox3f | ( | const SbVec3f & | minval,
|  | const SbVec3f & | maxval )
| inline

Constructs a box with the given corners.

The coordinates of min should be less than the coordinates of max if you want to make a valid box.

## ◆ SbBox3f() [4/6]

SbBox3f::SbBox3f | ( | const SbBox3d & | box | ) |
| inlineexplicit

Constructs an SbBox3f instance from the value in an SbBox3d instance.

Since
  Coin 2.5

## ◆ SbBox3f() [5/6]

SbBox3f::SbBox3f | ( | const SbBox3s & | box | ) |
| inlineexplicit

Constructs an SbBox3f instance from the value in an SbBox3s instance.

Since
  Coin 2.5

## ◆ SbBox3f() [6/6]

SbBox3f::SbBox3f | ( | const SbBox3i32 & | box | ) |
| inlineexplicit

Constructs an SbBox3f instance from the value in an SbBox3i32 instance.

Since
  Coin 2.5

## Member Function Documentation

## ◆ setBounds() [1/5]

SbBox3f & SbBox3f::setBounds | ( | float | minx,
|  | float | miny,
|  | float | minz,
|  | float | maxx,
|  | float | maxy,
|  | float | maxz )
| inline

Reset the boundaries of the box.

minx should be less than maxx, miny should be less than maxy and minz should be less than maxz if you want to make a valid box.

Returns reference to self.

See also
  getBounds().

## ◆ setBounds() [2/5]

SbBox3f & SbBox3f::setBounds | ( | const SbVec3f & | minval,
|  | const SbVec3f & | maxval )
| inline

Reset the boundaries of the box with the given corners.

The coordinates of min should be less than the coordinates of max if you want to make a valid box.

Returns reference to self.

See also
  getBounds().

## ◆ setBounds() [3/5]

SbBox3f & SbBox3f::setBounds | ( | const SbBox3d & | box | ) |

Reset the boundaries to the boundaries of the given box.

Returns reference to self.

See also
  getBounds().

## ◆ setBounds() [4/5]

SbBox3f & SbBox3f::setBounds | ( | const SbBox3s & | box | ) |

Reset the boundaries to the boundaries of the given box.

Returns reference to self.

See also
  getBounds().

## ◆ setBounds() [5/5]

SbBox3f & SbBox3f::setBounds | ( | const SbBox3i32 & | box | ) |

Reset the boundaries to the boundaries of the given box.

Returns reference to self.

See also
  getBounds().

## ◆ getBounds() [1/2]

void SbBox3f::getBounds | ( | float & | minx,
|  | float & | miny,
|  | float & | minz,
|  | float & | maxx,
|  | float & | maxy,
|  | float & | maxz ) const
| inline

Returns the box boundaries.

See also
  setBounds().

## ◆ getBounds() [2/2]

void SbBox3f::getBounds | ( | SbVec3f & | minobj,
|  | SbVec3f & | maxobj ) const
| inline

Returns the box corner points.

See also
  setBounds().

## ◆ getMin() [1/2]

const SbVec3f & SbBox3f::getMin | ( | void |  | ) | const
| inline

Returns the minimum point. This should usually be the lower left corner point of the box.

See also
  getOrigin(), getMax().

## ◆ getMin() [2/2]

SbVec3f & SbBox3f::getMin | ( | void |  | ) |
| inline

Returns a modifiable reference to the minimum point.

## ◆ getMax() [1/2]

const SbVec3f & SbBox3f::getMax | ( | void |  | ) | const
| inline

Returns the maximum point. This should usually be the upper right corner point of the box.

See also
  getMin().

## ◆ getMax() [2/2]

SbVec3f & SbBox3f::getMax | ( | void |  | ) |
| inline

Returns a modifiable reference to the maximum point.

## ◆ extendBy() [1/2]

void SbBox3f::extendBy | ( | const SbVec3f & | point | ) |

Extend the boundaries of the box by the given point, i.e. make the point fit inside the box if it isn't already so.

## ◆ extendBy() [2/2]

void SbBox3f::extendBy | ( | const SbBox3f & | box | ) |

Extend the boundaries of the box by the given box parameter. This is equal to calling extendBy() twice with the corner points.

## ◆ transform()

void SbBox3f::transform | ( | const SbMatrix & | matrix | ) |

Transform the box by the matrix, and change its boundaries to contain the transformed box.

Doesn't touch illegal/empty boxes.

## ◆ makeEmpty()

void SbBox3f::makeEmpty | ( | void |  | ) |

Marks this as an empty box.

See also
  isEmpty().

## ◆ isEmpty()

SbBool SbBox3f::isEmpty | ( | void |  | ) | const
| inline

Check if this has been marked as an empty box.

See also
  makeEmpty().

## ◆ hasVolume()

SbBool SbBox3f::hasVolume | ( | void |  | ) | const
| inline

Check if the box has been correctly specified and by that virtue has "positive" volume, i.e. all coordinates of its upper right corner (the maximum point) are greater than the corresponding coordinates of its lower left corner (the minimum point).

## ◆ getVolume()

float SbBox3f::getVolume | ( | void |  | ) | const
| inline

Returns the volume of the box.

## ◆ intersect() [1/2]

SbBool SbBox3f::intersect | ( | const SbVec3f & | point | ) | const

Check if the given point lies within the boundaries of this box.

## ◆ intersect() [2/2]

SbBool SbBox3f::intersect | ( | const SbBox3f & | box | ) | const

Check if the given box lies entirely or partially within the boundaries of this box.

## ◆ getClosestPoint()

SbVec3f SbBox3f::getClosestPoint | ( | const SbVec3f & | point | ) | const

Return the point on the box closest to the given point. If the given point equals the center, the center point of the positive Z face is returned.

## ◆ outside()

SbBool SbBox3f::outside | ( | const SbMatrix & | mvp,
|  | int & | cullbits ) const

Check if the box is outside the view volume defined by the mvp matrix. Sets cullbits according to which planes we're inside or outside. Bit 0 (0x1) is cleared when box is completely inside left and right clipping planes. Bit 1 (0x2) is cleared when box is inside top and bottom clipping planes. Bit 2 (0x4) is cleared when box is inside near and far clipping planes.

Returns `TRUE` if box is completely outside one of the clipping planes. `FALSE` otherwise.

## ◆ getCenter()

SbVec3f SbBox3f::getCenter | ( | void |  | ) | const
| inline

Returns the center point of the box.

## ◆ getOrigin()

void SbBox3f::getOrigin | ( | float & | x0,
|  | float & | y0,
|  | float & | z0 ) const
| inline

Returns the coordinates of the box origin (i.e. the lower left corner).

See also
  getMin().

## ◆ getSize() [1/2]

void SbBox3f::getSize | ( | float & | dx,
|  | float & | dy,
|  | float & | dz ) const
| inline

Returns width, height and depth of box.

## ◆ getSize() [2/2]

SbVec3f SbBox3f::getSize | ( | void |  | ) | const
| inline

Returns width, height and depth of box as a 3D vector.

Since
  Coin 3.0

## ◆ getSpan()

void SbBox3f::getSpan | ( | const SbVec3f & | dir,
|  | float & | dmin,
|  | float & | dmax ) const

Find the span of the box in the given direction (i.e. how much room in the given direction the box needs). The distance is returned as the minimum and maximum distance from origo to the closest and furthest plane defined by the direction vector and each of the box' corners. The difference between these values gives the span.

## ◆ print()

void SbBox3f::print | ( | FILE * | fp | ) | const

Dump the state of this object to the fp file stream. Only works in debug version of library, method does nothing in an optimized build.

## Friends And Related Symbol Documentation

## ◆ operator==()

int operator== | ( | const SbBox3f & | b1,
|  | const SbBox3f & | b2 )
| related

Check b1 and b2 for equality.

## ◆ operator!=()

int operator!= | ( | const SbBox3f & | b1,
|  | const SbBox3f & | b2 )
| related

Check b1 and b2 for inequality.

The documentation for this class was generated from the following files:

- SbBox3f.h
- SbBox3f.cpp